	package baseLine;

	import java.io.BufferedInputStream;
	import java.io.BufferedOutputStream;
	import java.io.BufferedReader;
	import java.io.BufferedWriter;
	import java.io.File;
	import java.io.FileInputStream;
	import java.io.FileNotFoundException;
	import java.io.FileOutputStream;
	import java.io.FileReader;
	import java.io.FileWriter;
	import java.io.IOException;
	import java.io.ObjectInputStream;
	import java.io.ObjectOutputStream;
	import java.util.ArrayList;

	import newsProcessor.NewsTrend;

	public class CreateBaseLineFilesAfterFV {
		
		public static void main(String[] args) throws IOException, ClassNotFoundException {
			File[] dir = new File("c:/master/trendsbystock/trendsbystock44min0.5/").listFiles();
			ArrayList<String> FeatureVector = new ArrayList<String>();
			
			int count = 40674;
			ObjectInputStream ois = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/baseline/featurevector"))));
			FeatureVector = (ArrayList<String>) ois.readObject();
			
			ObjectInputStream ois2  = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/baseline/dfvector"))));
			ArrayList<Integer> documentFrequency = (ArrayList<Integer>) ois2.readObject();

			BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream(new File("c:/masteR/baseline/wekaBaseline.arff")));
			
			String outputString = "@Relation DataMaster\n";
			for(int k = 0; k<FeatureVector.size();k++){
				outputString+="@ATTRIBUTE\t";
				outputString+= k+1;
				
				
				outputString+="\tNUMERIC\n";
				bos.write(outputString.getBytes());
				outputString="";
			}	
			outputString = "@ATTRIBUTE\tClass\t{pos,neg,zero}\n@data\n";
			bos.write(outputString.getBytes());
			outputString="";
			for(int i = 0; i < dir.length; i++){
				System.out.println(dir[i].getName());
//			for(int i = 0; i < 10; i++){
				ObjectInputStream oisNT = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/trendsbystock/trendsbystock44min0.5/"+dir[i].getName()+"/newstrends"))));
				ArrayList<NewsTrend> nt = (ArrayList<NewsTrend>) oisNT.readObject();
//				System.out.println(dir[i].getName());
				for(int lol = 0; lol<nt.size(); lol++){
					if(nt.get(lol).getDirection()==-2){
						continue;
					}
					
					ArrayList<Integer> tf = new ArrayList<>();
					for(int fill = 0; fill < FeatureVector.size();fill++){
						tf.add(0);
					}
					String name = nt.get(lol).getDirectory().substring(nt.get(lol).getDirectory().length()-6) + ".txt";
//					System.out.println(name);
					if (!new File("c:/master/CRFresulttest/" + name).exists()) {
						continue;
					}
					BufferedReader br = new BufferedReader(new FileReader(new File("c:/master/CRFresulttest/" + name)));
//					System.out.println(name);
					String content = "";
				
						while (br.ready()){
							content = br.readLine();
							String tempTerm = "";
							for(int j = 0; j<content.length();j++){
								if(content.charAt(j)=='\t'){
									break;
								}
								else {
									tempTerm+=content.charAt(j);
								}
							}
							int index = FeatureVector.indexOf(tempTerm);
							int tempTF = tf.get(index);
							tempTF++;
							tf.set(index, tempTF);
//							System.out.println(content);
						}
						Double[] tfidf = new Double[FeatureVector.size()];
						
						outputString+="{";
						for (int k = 0; k < FeatureVector.size(); k++) {
//							if(k%1000==0){
//								System.out.println(k);
//							}
							int tempTF = tf.get(k);
							double idf = Math.log(count/documentFrequency.get(k));
							double tempDouble = tempTF*idf;
							tfidf[k] = tempDouble;
							if(tempDouble>0){
								outputString+="" + (k) + " " + tempDouble;
								bos.write(outputString.getBytes());
								outputString=",";
							}
						}
						
						switch(nt.get(lol).getDirection()){
						case(-1):outputString+="322839 neg";break;
						case(1):outputString+="322839 pos";break;
						case(0):outputString+="322839 zero";break;
						}
						
						outputString+="}\n";
						bos.write(outputString.getBytes());
						outputString="";
//						System.out.println("ferdig med filen.");
				}
				
			}

			
			bos.write(outputString.getBytes());
			bos.close();
			
				
		
		}
	

}
