package baseLine;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;

import javax.print.DocFlavor;

import newsProcessor.NewsTrend;

public class CreateBaselineRandomFeatures {
	
	public static void main(String[] args) throws IOException, ClassNotFoundException {
		File[] dir = new File("c:/master/trendsbystock/trendsbystock44min0.5/").listFiles();
		
		File[] featureVectors = new File("c:/master/baseline/randomfeaturevector/").listFiles();
		ArrayList<String> FeatureVector = new ArrayList<String>();
		
		int count = 0;
//		for(int fv = 0; fv<featureVectors.length; fv++){
//		for(int fv = 0; fv < 1;fv++){
//			System.out.println(fv);
//			ObjectInputStream ois = new ObjectInputStream(new BufferedInputStream(new FileInputStream(featureVectors[fv])));
			ObjectInputStream ois = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/baseline/featurevectorfixed"))));
			FeatureVector =(ArrayList<String>) ois.readObject();
			Integer[] documentFrequency = new Integer[FeatureVector.size()];
			System.out.println(FeatureVector.size());
			for(int k = 0; k < documentFrequency.length;k++){
				documentFrequency[k] = 0;
			}
			
			for(int i = 0; i < dir.length; i++){
//			for(int i = 0; i < 10; i++){
				ObjectInputStream oisNT = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/trendsbystock/trendsbystock44min0.5/"+dir[i].getName()+"/newstrends"))));
				ArrayList<NewsTrend> nt = (ArrayList<NewsTrend>) oisNT.readObject();
				
				for(int lol = 0; lol<nt.size(); lol++){
						
					ArrayList<Integer> tempDocFreq = new ArrayList();
					for(int fill = 0; fill < FeatureVector.size(); fill++){
						tempDocFreq.add(0);
					}
					String name = nt.get(lol).getDirectory().substring(nt.get(lol).getDirectory().length()-6) + ".txt";
					if (!new File("c:/master/CRFresulttest/" + name).exists()) {
						continue;
					}
					BufferedReader br = new BufferedReader(new FileReader(new File("c:/master/CRFresulttest/" + name)));
					String content = "";
				
						while (br.ready()){
							content = br.readLine();
							String tempTerm = "";
							for(int j = 0; j<content.length();j++){
								if(content.charAt(j)=='\t'){
									break;
								}
								else {
									tempTerm+=content.charAt(j);
								}
							}
							int index = FeatureVector.indexOf(tempTerm);
							if (index == -1) {
								continue;
								
							}
							if(tempDocFreq.get(index)!=0){
								continue;
							}
							else{
								tempDocFreq.set(index, 1);
								}
						}
							
					for(int k = 0; k<tempDocFreq.size();k++){
						int temp = documentFrequency[k];
						temp+= tempDocFreq.get(k);
						documentFrequency[k] = temp;
					}
				}
			}
			
		
//			BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream(new File("c:/masteR/baseline/baselinefiles/wekaBaseline"+(fv+1)+".arff")));
			BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream(new File("c:/masteR/baseline/wekaBaselinefixed.arff")));
			int totalFeatures = documentFrequency.length;
			System.out.println("Begin writing");
			String outputString = "@relation lol\n";
			for(int k = 0; k<FeatureVector.size();k++){
				outputString+="@ATTRIBUTE\t";
				outputString+= k;
				
				
				outputString+="\tNUMERIC\n";
				bos.write(outputString.getBytes());
				outputString="";
			}	
			outputString = "@ATTRIBUTE\tClass\t{pos,neg,zero}\n@data\n";
			bos.write(outputString.getBytes());
			outputString="";
			for(int i = 0; i < dir.length; i++){
				System.out.println(dir[i].getName());
	//		for(int i = 0; i < 10; i++){
				ObjectInputStream oisNT = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/trendsbystock/trendsbystock44min0.5/"+dir[i].getName()+"/newstrends"))));
				ArrayList<NewsTrend> nt = (ArrayList<NewsTrend>) oisNT.readObject();
	//			System.out.println(dir[i].getName());
				for(int lol = 0; lol<nt.size(); lol++){
					if(nt.get(lol).getDirection()==-2){
						continue;
					}
					
					ArrayList<Integer> tf = new ArrayList<>();
					for(int fill = 0; fill < FeatureVector.size();fill++){
						tf.add(0);
					}
					String name = nt.get(lol).getDirectory().substring(nt.get(lol).getDirectory().length()-6) + ".txt";
	//				System.out.println(name);
					if (!new File("c:/master/CRFresulttest/" + name).exists()) {
						continue;
					}
					BufferedReader br = new BufferedReader(new FileReader(new File("c:/master/CRFresulttest/" + name)));
	//				System.out.println(name);
					String content = "";
				
						while (br.ready()){
							content = br.readLine();
							String tempTerm = "";
							for(int j = 0; j<content.length();j++){
								if(content.charAt(j)=='\t'){
									break;
								}
								else {
									tempTerm+=content.charAt(j);
								}
							}
							int index = FeatureVector.indexOf(tempTerm);
							if(index == -1){
								continue;
							}
							int tempTF = tf.get(index);
							tempTF++;
							tf.set(index, tempTF);
	//						System.out.println(content);
						}
						Double[] tfidf = new Double[FeatureVector.size()];
						
						outputString+="{";
						for (int k = 0; k < FeatureVector.size(); k++) {
	//						if(k%1000==0){
	//							System.out.println(k);
	//						}
							int tempTF = tf.get(k);
							double idf = 0;
							if(documentFrequency[k]!= 0){
								idf = Math.log(48017/documentFrequency[k]);
							}
							else {
//								System.out.println(FeatureVector.get(k));
							}
							double tempDouble = tempTF*idf;
							tfidf[k] = tempDouble;
							if(tempDouble>0){
								outputString+="" + k + " " + tempDouble;
								bos.write(outputString.getBytes());
								outputString=",";
							}
						}
						int direction = nt.get(lol).getDirection();
						switch(direction){
						case(-1):outputString+=totalFeatures + " neg";break;
						case(1):outputString+=totalFeatures + " pos";break;
						case(0):outputString+=totalFeatures + " zero";break;
						}
						bos.write(outputString.getBytes());
						outputString="";
						outputString+="}\n";
						
	//					System.out.println("ferdig med filen.");
				}
				
			}
	
			
			bos.write(outputString.getBytes());
			bos.close();
			
			
		
	}
}
