package baseLine;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class CreateStopWordsList {
	
	public static void main(String[] args) throws IOException {
		File[] dir = new File("C:/master/crfresulttest/").listFiles();
		ArrayList<Term> terms = new ArrayList<>();
		ArrayList<String> termStrings = new ArrayList<>();
		ArrayList<Integer> termsFreq = new ArrayList<>();
		System.out.println(dir.length);
		for( int i = 0 ; i < dir.length; i++){
			if(i%100==0){
				System.out.println(i);
				System.out.println(termStrings.size());
			}
			BufferedReader br = new BufferedReader(new FileReader(dir[i]));
			String content = "";
			while(br.ready()){
				String tempString = "";
				content = br.readLine();
				boolean newWord = true;
				for(int j = 0; j < content.length();j++){
					if(content.charAt(j)=='\t'){
						tempString = tempString.toLowerCase();
						int index = termStrings.indexOf(tempString);
						if(index!=-1){
							
							int tempFreq = termsFreq.get(index);
							tempFreq++;
							termsFreq.set(index, tempFreq);
						}
						else {
							termStrings.add(tempString);
							termsFreq.add(1);
						}
						break;
					}
					else {
						tempString+=content.charAt(j);
					}
				}
			}
		}
		for(int i = 0; i < termStrings.size(); i++){
			terms.add(new Term(termStrings.get(i),termsFreq.get(i)));
		}
		Collections.sort(terms, new CustomComparator());
		
		BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream(new File("c:/master/baseline/stopwords.txt")));
		System.out.println(terms.size());
		for(Term term : terms){
			bos.write(("" +term.getTerm() + '\t' + term.getFreq()+'\n').getBytes());
		}
		bos.close();
	}

}
