package baseLine;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.util.ArrayList;

public class MakeFeatureVector {
	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new FileReader(new File("c:/master/baseline/stopwords2.txt")));
		ArrayList<String> AllFeatures = new ArrayList<>(); 
		while(br.ready()){
			
			String content = br.readLine();
			String tempString = "";
			for(int i = 0; i <content.length();i++){
				if (content.charAt(i)=='\t'){
					AllFeatures.add(tempString);
					break;
				}
				else {
					tempString+=content.charAt(i);
				}
			}
		}
		ObjectOutputStream oos = new ObjectOutputStream(new BufferedOutputStream(new FileOutputStream(new File("c:/master/baseline/featurevectorFixed"))));
		oos.writeObject(AllFeatures);
		oos.close();
//		for (int i = 0; i < 10; i++){
//			System.out.println(i);
//			ArrayList<String> featureVector = new ArrayList<>();
//			int featuresize = 0;
//			while(featureVector.size()<7690){
//				if(featureVector.size()!=featuresize){
//					featuresize = featureVector.size();
//					System.out.println(featuresize);
//				}
//				for(int k = 0; k < AllFeatures.size(); k++){
//					
//					String tempFeature = AllFeatures.get(k);
//					double ratio = (double)7690/AllFeatures.size();
//					double random = Math.random();
//					if(!featureVector.contains(tempFeature)){
//						if(random<(ratio)){
//							featureVector.add(tempFeature);
//						}
//					}
//					if (featureVector.size()==7690) {
//						break;
//					}
//				}
//			}
//			
//			ObjectOutputStream oos = new ObjectOutputStream(new BufferedOutputStream(new FileOutputStream(new File("c:/master/baseline/randomFeatureVector/FeatureVectorWithStopwords" +(i+1)))));
//			oos.writeObject(featureVector);
//			oos.close();
//			break;
//		}
	}

}
