package combineDifferentDocs;

import java.io.File;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

public class Main {
	
	public static void main(String[] args) throws InterruptedException {
		
		ExecutorService exService = new ThreadPoolExecutor(6, 6, 10,TimeUnit.SECONDS, new ArrayBlockingQueue<Runnable>(6,true), new ThreadPoolExecutor.CallerRunsPolicy());
		
		File inputDir =  new File("c:/master/NERPOStagged/");
		File[] dirList = inputDir.listFiles();
		
		for(int i = 0 ; i <dirList.length;i++){
			Thread t = new CRFplusplus(dirList[i].getName());
			exService.submit(t);
		}
		exService.shutdown();
		
	}

}
