package crf;

import java.io.File;
import java.io.IOException;
import java.lang.ProcessBuilder.Redirect;

public class RunPOStagger extends Thread{
	
	public RunPOStagger(String symbol, String inputFilename, String outputFilename) throws InterruptedException{
		
		ProcessBuilder pb = new ProcessBuilder("java","-cp","c:\\test\\pos\\stanford-postagger.jar","-Xmx3g","edu.stanford.nlp.tagger.maxent.MaxentTagger","-model","c:\\test\\pos\\models\\english-left3words-distsim.tagger","-textFile","c:\\master\\newsTextFiles\\"+symbol+"/"+inputFilename);
		pb.directory(new File("c:\\test\\pos"));
//		File saveDir = new File("c:/master/postagged/"+symbol+"/");
//		if(!saveDir.exists()){
//			saveDir.mkdir();
//		}
		File log = new File("c:\\master\\POStagged/"+outputFilename);
		pb.redirectOutput(Redirect.to(log));
		try {
			Process process = pb.start();
			process.waitFor();
			
		} catch (IOException e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		
	}

}
