package crf;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;

import newsProcessor.News;
import newsProcessor.NewsTrend;

public class SelectRandomNews {
	
	public static void getRandomNews() throws ClassNotFoundException, IOException{
		
		Math.random();
		
		File dir = new File("c:/master/trendsbystock/trendsbystock44min0.5/");
		File[] dirList = dir.listFiles();
		
		int pos = 0;
		int neg = 0;
		int zero = 0;
		for(int i = 0; i < dirList.length;i++){
			FileInputStream fis = new FileInputStream(dirList[i].getAbsolutePath()+"/newstrends");
			BufferedInputStream bis = new BufferedInputStream(fis);
			ObjectInputStream ois = new ObjectInputStream(bis);
			ArrayList<NewsTrend> newsTrends = (ArrayList<NewsTrend>)ois.readObject();
			

			for (int j = 0; j<newsTrends.size();j++){
				
				if(newsTrends.get(j).getDirection()!=-2){
					if(Math.random()>0.99){
						FileInputStream fis2 = new FileInputStream(new File(newsTrends.get(j).getDirectory()));
						BufferedInputStream bis2 = new BufferedInputStream(fis2);
						ObjectInputStream ois2 = new ObjectInputStream(bis2);
						News news = (News)ois2.readObject();

						FileReader fr = new FileReader(new File("c:/master/newstextfiles/" + news.getSymbol() + "/"+ newsTrends.get(j).getDirectory().substring(newsTrends.get(j).getDirectory().length()-6)));
						BufferedReader br = new BufferedReader(fr);
						String newsMessage = "" + newsTrends.get(j).getDirection() + "\n";
						while(br.ready()){
							newsMessage+= br.readLine() +"\n";
						}
						File testFile = new File("C:/master/newstobetaggedforcrf/" +  news.getSymbol()+"/");
						if(!testFile.exists()){
							testFile.mkdir();
						}
						
						FileOutputStream fos = new FileOutputStream(new File("C:/master/newstobetaggedforcrf/" +  news.getSymbol()+"/"+ newsTrends.get(j).getDirectory().substring(newsTrends.get(j).getDirectory().length()-6)));
						fos.write(newsMessage.getBytes());
						switch (newsTrends.get(j).getDirection()){
						case(-1):neg++;break;
						case(0):zero++;break;
						case(1):pos++;break;
						
					}
					
					}
					
				}
				
			}
			
			
		}
		System.out.println("pos: " + pos);
		System.out.println("neg: " + neg);
		System.out.println("zero: " + zero);
	}

}
