package newsProcessor;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.io.StringReader;

public class ExtractFields implements Serializable{
	
	public static boolean myContainsMethod(String line, String searchTerm){
		
//		System.out.println(line);
//		System.out.println(searchTerm);
		if(line.length()==0 || searchTerm.length()==0){
			return false;
		}
//		System.out.println(line);
//		System.out.println(searchTerm);
		String testString = "";
		for(int i = 0; i<line.length();i++){
			testString+=line.charAt(i);
			if (testString.length()>searchTerm.length()){
				testString = testString.substring(1);
			}
			if (testString.equals(searchTerm)){
				
				return true;
			}
		}
		
		
		return false;
	}

	public static News extractFields(String filepath) throws IOException {
		

		FileReader fr = new FileReader(new File(filepath));
		BufferedReader br = new BufferedReader(fr);
		
		String title ="";
		String symbol = "";
		String name = "";
		String message="";
		String category="";
		String date="";
		
		String content = "";
		int lineCounter = 0;
		while (br.ready()){
			lineCounter++;
			content = br.readLine();
			if (lineCounter >1400){
		
//				System.out.println(content);
				if(myContainsMethod(content,"Beklager, ingen melding funnet")){
					break;
				}
				else if(myContainsMethod(content, "Dato/tid")){
					lineCounter++;
					String tempString = br.readLine();
					tempString= tempString.substring(tempString.indexOf('>')+1, tempString.length()-10);
//					System.out.println(tempString);
					String tempDate = "";
//					"20120130T123900"
//					System.out.println("20120130T123900");
//					System.out.println(tempString);
//					System.out.println(filepath);
					tempDate+= tempString.substring(6, 10);
					tempDate+= tempString.substring(3,5);
					tempDate+= tempString.substring(0,2);
					tempDate+= "T";
					tempDate+= tempString.substring(11,13);
					tempDate+= tempString.substring(14,16);
					tempDate+= "00";
					date = tempDate;
					
				}
				else if(myContainsMethod(content,"Utsteder") && !myContainsMethod(content, "UtstederID")){
					lineCounter++;
					String tempString = br.readLine();
					tempString = tempString.substring(tempString.indexOf('>')+1, tempString.length()-10);
					name = tempString;
				}
				else if(myContainsMethod(content, "UtstederID")){
					lineCounter++;
					String tempString = br.readLine();
					tempString = tempString.substring(tempString.indexOf('>')+1, tempString.length()-10);
					symbol = tempString;
					
				}
				else if(myContainsMethod(content, "Kategori")){
					String tempString;
					while(!myContainsMethod(tempString = br.readLine(),">")){
						lineCounter++;
					}
					lineCounter++;
					tempString = tempString.substring(tempString.indexOf('>')+1, tempString.length()-5);
					category = tempString;
					
					
				}
				else if(myContainsMethod(content,"Tittel")){
					String tempString = br.readLine();
					tempString = tempString.substring(tempString.indexOf('>')+1, tempString.length()-10);
					String replaceString = tempString.replace("&#044;", ",");
					String replaceString2 = replaceString.replace("&#046;", ".");
					String replaceString3 = replaceString2.replace("&#040;", "(");
					String replaceString4 = replaceString3.replace("&#041;", ")");
					String replaceString5 = replaceString4.replace("&#045;","-");
					replaceString5 = replaceString5.replace("&#047;", "/");
					title = replaceString5;
					
				}
				else if(myContainsMethod(content, "<pre>")){
					String text = content;
					String tempString;
					if(!myContainsMethod(content, "</pre>")){
						while(!myContainsMethod(tempString=br.readLine(), "</pre>")){
							text+=tempString;
						}
						text+=tempString;
					}
					
//					System.out.println(text);
					text = text.substring(46,text.length()-22);
					String replaceString = text.replace("&#044;", ",");
					String replaceString2 = replaceString.replace("&#046;", ".");
					String replaceString3 = replaceString2.replace("&#040;", "(");
					String replaceString4 = replaceString3.replace("&#041;", ")");
					String replaceString5 = replaceString4.replace("&#045;","-");
					replaceString5 = replaceString5.replace("&#047;", "/");
					
					message = replaceString5;
					
					
				}
				
			}
//			if(lineCounter == 1472){
//				String tempString = content;
//				tempString= tempString.substring(tempString.indexOf('>')+1, tempString.length()-10);
////				System.out.println(tempString);
//				String tempDate = "";
////				"20120130T123900"
////				System.out.println("20120130T123900");
//				tempDate+= tempString.substring(6, 10);
//				tempDate+= tempString.substring(3,5);
//				tempDate+= tempString.substring(0,2);
//				tempDate+= "T";
//				tempDate+= tempString.substring(11,13);
//				tempDate+= tempString.substring(14,16);
//				tempDate+= "00";
//				date = tempDate;
//			}
//			else if(lineCounter == 1474){
//				String tempString = content;
//				tempString = tempString.substring(tempString.indexOf('>')+1, tempString.length()-10);
//				name = tempString;
//				
//			}
//			else if (lineCounter==1476){
//				String tempString = content;
//				tempString = tempString.substring(tempString.indexOf('>')+1, tempString.length()-10);
//				symbol = tempString;
//				
//			}
//			else if (lineCounter==1485){
//				String tempString = content;
//				tempString = tempString.substring(tempString.indexOf('>')+1, tempString.length()-5);
//				category = tempString;
//			}
//			else if (lineCounter==1492){
//				boolean stop = false;
////				System.out.println("oaisjdoiasjsiodoasidoiasdjioasdjiodj");
//				while(!stop){
//					lineCounter++;
//					String tempString = br.readLine();
//					System.out.println(tempString);
//					String testString = "";
//					for (int i = 0; i<tempString.length();i++){
//						testString+=tempString.charAt(i);
//						if(testString.length()>7){
//							testString = testString.substring(1);
//						}
//						
//						String stopSequence = "Vedlegg";
//						if (stopSequence.equals(testString)){
////							System.out.println("oasjdouasjosdj");
//							lineCounter = 1500;
//							stop = true;
//							break;
//						}
//					}
//				}
				
				
				
//			}
//			else if(lineCounter==1508){
//				String tempString = content;
//				System.out.println(filepath);
//				System.out.println(content);
//				tempString = tempString.substring(tempString.indexOf('>')+1, tempString.length()-10);
//				title = tempString;
//				
//			}
//			else if(lineCounter==1511){
//				String tempString = content;
//				boolean stop = false;
//				while (!stop){
//					lineCounter++;
//					content = br.readLine();
//					tempString += content;
//					String endCheck = "";
//					String stopSequence = "</pre>";
////					System.out.println(lineCounter);
//					for(int i = 0; i<content.length();i++){
//						
//						endCheck += content.charAt(i);
//						if (endCheck.length() > 6){
//							endCheck = endCheck.substring(1);
//						}
//						if (endCheck.equals(stopSequence)){
//							stop = true;
//							break;
//						}
//						
//					}
//				}
//				
//				tempString = tempString.substring(46,tempString.length()-22);
//				String test = tempString.replace("&#044;", ",");
//				test = test.replace("&#046;", ".");
//				message = test;
//				
//			}
			
		
		}
		
		return new News(title, message, category, date, symbol, name);

	}

}
