package newsProcessor;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.ArrayList;

import stockPrices.TimeSeries;
import trends.CheckTrend;
import trends.ClosestTime;

public class MatchNewsWithTrend implements Serializable{
	
//	public static int getTrend(File file, int period, double threshHold) throws IOException, ClassNotFoundException, InterruptedException{
	public static int getTrend(File file) throws IOException, ClassNotFoundException, InterruptedException{
		
//		System.out.println(file.getName());
		File[] dirList = file.listFiles();
		if(dirList.length==0){
			return -1;
		}
		
		FileInputStream fis2 = new FileInputStream(new File("c:/master/timeseries/"+file.getName()));
//		System.out.println("TEST");
		ObjectInputStream ois2 = new ObjectInputStream(fis2);
		TimeSeries ts = (TimeSeries)ois2.readObject();
		for(int period = 1; period <= 120; period++){
			for(double threshHold = 0.5; threshHold <= 10; threshHold +=0.5){
				
				ArrayList<NewsTrend> newsTrends = new ArrayList<>();
				
				if(!new File("c:/master/trendsbystock/trendsbystock" + period + "min" + threshHold + "/").exists()){
					new File("c:/master/trendsbystock/trendsbystock" + period + "min" + threshHold + "/").mkdir();
				}
				File newDir = new File("c:/master/trendsbystock/trendsbystock" + period + "min" + threshHold + "/" + file.getName());
				if(!newDir.exists()){
					newDir.mkdir();
//					System.out.println("created directory: " + newDir.getAbsolutePath());
				}
				else if(!(newDir.listFiles().length == 0)){
					continue;
				}
				
				for (int i = 0; i < dirList.length; i++) {
					
					FileInputStream fis = new FileInputStream(new File("c:/master/processednewsbystock/" + file.getName()+"/"+dirList[i].getName()));
					ObjectInputStream ois = new ObjectInputStream(fis);
					
					News news = (News)ois.readObject();
					
					String date = news.getDate();
					
		//			System.out.println("fr ct");
		//			System.out.println(news.getDate());
		//			System.out.println(news.getDate().length());
		//			System.out.println(ts.getDate().size());
		//			System.out.println(news.getSymbol());
					if (ts.getDate().size()==0) {
						continue;
					}
					if(Integer.parseInt(news.getDate().substring(0,8))<ts.getDate().get(0)){
		//				System.out.println(dirList[i].getAbsolutePath() + "skipped");
						continue;
					}
		//			System.out.println(date);
		//			System.out.println("fr ct");
		//			System.out.println(dirList[i].getName());
		//			if (news.getName().equals("AKVA")){
		//				System.out.println(dirList[i].getName());
		//			}
		//			System.out.println(dirList[i].getName());
					ClosestTime ct = new ClosestTime(date, ts);
		//			System.out.println("etter ct");
					
					int trend = -2;
					
					if(ct.isFalse==false){
						CheckTrend cTrend = new CheckTrend(ct.getTransactionID(),ts.getTime().get(ct.getTransactionID()), period , ct.getOffset() , ct.getDayDiff(), ts,  threshHold, 0.3, ct.isAfterClosing, news.getDate());
						
						trend = cTrend.getDirection();
						if (cTrend.getNumOfTransactions()==0){
							trend = -2;
						}
		//				System.out.println("IKASDJKn");
					}
					NewsTrend nt = new NewsTrend(dirList[i].getName(), trend, dirList[i].getAbsolutePath());
					newsTrends.add(nt);
//					FileOutputStream fos = new FileOutputStream(newDir+"/"+dirList[i].getName());
//		//			System.out.println(trend);
//					fos.write(("" +trend).getBytes());
//					fos.close();
					
					
					}
				FileOutputStream fos = new FileOutputStream(newDir + "/newsTrends");
				ObjectOutputStream oos = new ObjectOutputStream(fos);
				oos.writeObject(newsTrends);
			}
			
			
		}
		
//		if(!symbols.contains(news.getSymbol())){
//			System.out.println("KASDNKJASNdjk");
//			return -2;
//			
//		}
		
//		System.out.println(news.getSymbol());
		
		
		
		
		return 1;
		
		
	}
}
