package svm;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.util.ArrayList;

public class PrintVector {
	
	public static void main(String[] args) throws ClassNotFoundException, IOException {
		
		
		ObjectInputStream ois = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/svmprocess/documentFrequency"))));
		ObjectInputStream ois2 = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/svmprocess/FeatureVector"))));
		ArrayList<Integer> documentFrequency = (ArrayList<Integer>) ois.readObject();
		ArrayList<Feature> featureVector = (ArrayList<Feature>) ois2.readObject();
		BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream(new File("C:/master/svmProcess/docFreq.txt")));
		String outputString = "";
		
		for(int i = 0; i < featureVector.size(); i ++){
			
			for(int j = 0; j< featureVector.get(i).getList().size(); j++){
				
				outputString += featureVector.get(i).getList().get(j) + " ";
				
			}
			
			outputString += "\t\t" + documentFrequency.get(i) + "\n";
			if(documentFrequency.get(i)!=0){
				bos.write(outputString.getBytes());
			}
			else {
				System.out.println(outputString);
			}
			
			outputString = "";
			
		}
		
		bos.close();
	}

}
