package svm;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.ArrayList;

import edu.stanford.nlp.ling.HasWord;
import edu.stanford.nlp.tagger.maxent.MaxentTagger;

public class populateFeatureVectors implements Serializable{
	
	public static void main(String[] args) throws ClassNotFoundException, IOException {
		
		File allFiles = new File("c:/master/newstextfiles/");
		File[] dirList =allFiles.listFiles();
		
		
		ObjectInputStream ois = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/SVMProcess/featurevector2"))));
		
		ArrayList<Feature> featureVector = new ArrayList<>();
		try {
			featureVector = (ArrayList<Feature>) ois.readObject();
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		
		ArrayList<Integer> documentFrequency = new ArrayList<>();
		
		for(int i = 0; i < featureVector.size(); i++){
			documentFrequency.add(0);
		}
		System.out.println(documentFrequency.size());
		java.util.List<? extends java.util.List<? extends HasWord>> list = null;
		int count = 0;
		for(int i = 0; i < dirList.length;i++){
			File[] subDirList = dirList[i].listFiles();
			for(int j = 0; j < subDirList.length;j++){
				count++;
				if(count% 1000 == 0){
					System.out.println(count);
				}
				list = MaxentTagger.tokenizeText(new FileReader(subDirList[j]));
				ArrayList<String> document = new ArrayList<>();
				for(int lol = 0; lol< list.size();lol++){
					for(int lol2 = 0; lol2 <list.get(lol).size();lol2++){
						document.add(list.get(lol).get(lol2).toString());
					}
				}
				 
				for(int k = 0; k < featureVector.size();k++){
					boolean shouldStop = false;
					int featureSize = featureVector.get(k).getList().size();
					if(featureSize==0){
						continue;
					}
					if(featureSize>1){
						int[] tempArray = new int[featureSize];
						int saveIndex = 0;
						for(int l = 0; l<featureSize; l++){
							String tempString = featureVector.get(k).getList().get(l);
							
							boolean startOfFile = true;
							for(int indexOfDocument = 0; indexOfDocument<document.size();indexOfDocument++){
								if(featureVector.get(k).getList().get(l).equals(document.get(indexOfDocument))){
									tempArray[l] = 1;
//									System.out.println(indexOfDocument - saveIndex);
//									System.out.println(startOfFile);
									if(indexOfDocument-saveIndex>10 && !startOfFile){
										for(int indexIgjen = 0; indexIgjen < tempArray.length; indexIgjen++){
											tempArray[indexIgjen] = 0;
											
//											System.out.println("lol");
										}
										saveIndex = 0;
										startOfFile = true;
									}
									else{
										startOfFile = false;
										saveIndex = indexOfDocument;
									}
								}
								boolean test = false;
								if(tempArray[0] == 1){
									test = true;
								}
								for(int indexOfArray = 0; indexOfArray<tempArray.length; indexOfArray++){
									if(tempArray[indexOfArray]!= 1){
										test = false;
									}
								}
								if(test){
									int docFreq = documentFrequency.get(k);
									documentFrequency.set(k, docFreq+1);
									for(int lol = 0; lol < tempArray.length;lol++){
										
										
										tempArray[lol] = 0;
										
									}
									startOfFile = true;
									shouldStop = true;
									break;
								}
								
							}
							if(tempArray[l] != 1){
								break;
							}
							if (shouldStop){
								break;
							}
						}
					}
					else {
						if(document.contains(featureVector.get(k).getList().get(0))){
							int docFreq = documentFrequency.get(k);
							documentFrequency.set(k,docFreq+1);
						}
					}
				}
			
				
			}
			
		}
		
		ObjectOutputStream oos = new ObjectOutputStream(new BufferedOutputStream(new FileOutputStream(new File("c:/Master/SVMProcess/documentFrequency2"))));
		oos.writeObject(documentFrequency);
		oos.close();
//		for(int i = 0; i < list.size();i++){
//			System.out.println(list.get(i));
//		}
		
		
	}

}
