package svm;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;

import edu.stanford.nlp.ling.HasWord;
import edu.stanford.nlp.tagger.maxent.MaxentTagger;

public class populateTermFrequency {
	
public static void main(String[] args) throws ClassNotFoundException, IOException {
		
		File allFiles = new File("c:/master/newstextfiles/");
		File[] dirList =allFiles.listFiles();
		
		
		ObjectInputStream ois = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/SVMProcess/featurevector2"))));
		ObjectInputStream ois2 = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/SVMProcess/documentFrequency2"))));
		
		ArrayList<Feature> featureVector = new ArrayList<>();
		ArrayList<Integer> documentFrequency = new ArrayList<>();
		try {
			featureVector = (ArrayList<Feature>) ois.readObject();
			documentFrequency = (ArrayList<Integer>) ois2.readObject();
			
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		
		
//		System.out.println(documentFrequency.size());
		java.util.List<? extends java.util.List<? extends HasWord>> list = null;
		int count = 0;
		for(int i = 0; i < dirList.length;i++){
			File[] subDirList = dirList[i].listFiles();
			for(int j = 0; j < subDirList.length;j++){
				
				
				count++;
				if(count% 1000 == 0){
					System.out.println(count);
				}
				ArrayList<Integer> termFrequency = new ArrayList<>();
				
				list = MaxentTagger.tokenizeText(new FileReader(subDirList[j]));
				ArrayList<String> document = new ArrayList<>();
				for(int lol = 0; lol< list.size();lol++){
					for(int lol2 = 0; lol2 <list.get(lol).size();lol2++){
						document.add(list.get(lol).get(lol2).toString());
					}
				}
				 
				for(int k = 0; k < featureVector.size();k++){
					termFrequency.add(0);
					boolean shouldStop = false;
					int featureSize = featureVector.get(k).getList().size();
					if(featureSize==0){
						continue;
					}
					if(featureSize>1){
						int[] tempArray = new int[featureSize];
						int startFrom = 0;
						int saveIndex = 0;
						while(startFrom<document.size()){
							
							for(int l = 0; l<featureSize; l++){
								String tempString = featureVector.get(k).getList().get(l);
								
								boolean startOfFile = true;
								for(int indexOfDocument = startFrom; indexOfDocument<document.size();indexOfDocument++){
									if(featureVector.get(k).getList().get(l).equals(document.get(indexOfDocument))){
										tempArray[l] = 1;
										startFrom = indexOfDocument;
	//									System.out.println(indexOfDocument - saveIndex);
	//									System.out.println(startOfFile);
										int startCounting = 0;
										
										while(startCounting < 10){
											boolean iterate = true;
											
											if(featureVector.get(k).getList().contains(document.get(indexOfDocument+startCounting))){
												if(tempArray[featureVector.get(k).getList().indexOf(document.get(indexOfDocument+startCounting))] == 0){
											
												tempArray[featureVector.get(k).getList().indexOf(document.get(indexOfDocument + startCounting))] = 1;
												startCounting = 0;
												iterate= false;
												}
											}
											
											if(iterate) {
												startCounting++;
											}
											if(startCounting+indexOfDocument == document.size()){
												break;
											}
										}
										
//										if(indexOfDocument-saveIndex>10 && !startOfFile){
										
											
	//											System.out.println("lol");
//											}
//											saveIndex = 0;
//											startOfFile = true;
//										}
//										else{
//											startOfFile = false;
//											saveIndex = indexOfDocument;
//										}
									}
									boolean test = false;
									if(tempArray[0] == 1){
										test = true;
									}
									for(int indexOfArray = 0; indexOfArray<tempArray.length; indexOfArray++){
										if(tempArray[indexOfArray]!= 1){
											test = false;
										}
									}
									if(test){
										int termFreq = termFrequency.get(k);
										termFrequency.set(k, termFreq+1);
//										System.out.println(subDirList[j].getName());
										for(int lol = 0; lol < tempArray.length;lol++){
//											System.out.println(featureVector.get(k).getList().get(lol));
											tempArray[lol] = 0;
											
										}
										startOfFile = true;
	//									shouldStop = true;
										break;
									}
									else {
										for(int indexIgjen = 0; indexIgjen < tempArray.length; indexIgjen++){
											tempArray[indexIgjen] = 0;
										}
									}
									if(indexOfDocument == document.size()-1){
										shouldStop=true;
									}
									
								}
	//							if(tempArray[l] != 1){
	//								break;
	//							}
								
							}
							if (shouldStop){
								break;
							}
						}
					}
					else {
						for(int tempInt = 0; tempInt < document.size(); tempInt++){
							if(document.get(tempInt).equals(featureVector.get(k).getList().get(0))){
								int termFreq = termFrequency.get(k);
								termFrequency.set(k,termFreq+1);
							}
						}
					}
				}
			
				ObjectOutputStream oos = new ObjectOutputStream(new BufferedOutputStream(new FileOutputStream(new File("c:/Master/SVMProcess/termFrequency2/" + subDirList[j].getName()))));
				oos.writeObject(termFrequency);
				oos.close();
				
			}
			
		}
		
		
//		for(int i = 0; i < list.size();i++){
//			System.out.println(list.get(i));
//		}
		
		
	}

}
