package testTing;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;

import ptolemy.plot.Plot;
import ptolemy.plot.PlotApplication;

import newsProcessor.News;
import newsProcessor.NewsTrend;

public class CombineNewsTrendsWithResults {
	
	public static void readArrayAndCheckResults() throws ClassNotFoundException, IOException{
		
		double tresHold = 0.5;
		for(tresHold = 0.1;tresHold<=0.4;tresHold+=0.1){
			System.out.println(tresHold);
			double[] superResults = new double[120]; 
			File root = new File("c:/master/trendsbystock/trendsbystock1min0.5/");
			File[] dirList = root.listFiles();
			for(int index = 0; index <dirList.length;index++){
				System.out.println(dirList[index].getName());
				for(int periode = 1;periode<=120;periode++){
					FileInputStream fis = new FileInputStream("c:/master/trendsbystock/trendsbystock" +periode +"min"+tresHold+"/"+dirList[index].getName()+ "/newsTrends");
					BufferedInputStream bis = new BufferedInputStream(fis);
					ObjectInputStream ois = new ObjectInputStream(bis);
					ArrayList<NewsTrend> newsTrends = (ArrayList<NewsTrend>)ois.readObject();
					double results = 0;
					for(int i = 0; i <newsTrends.size();i++){
						FileInputStream newsReader = new FileInputStream(newsTrends.get(i).getDirectory());
						ObjectInputStream ois2 = new ObjectInputStream(newsReader);
						News news = (News)ois2.readObject();
						int timeofday =Integer.parseInt(news.getDate().substring(news.getDate().length()-6));
						if(timeofday>173000 || timeofday<90000){
							continue;
						}
						File testFile = new File("c:/master/newscombinedwithtrade/"+dirList[index].getName()+ "/"+ newsTrends.get(i).getDirectory().substring(newsTrends.get(i).getDirectory().length()-6));
						if(!testFile.exists()){
//							System.out.println(testFile.getAbsolutePath() + " does not exist!");
							continue;
						}
						FileInputStream resultsReader = new FileInputStream(testFile);
						ObjectInputStream ois3 = new ObjectInputStream(resultsReader);
						double[] resultsArray = (double[])ois3.readObject();
						if (newsTrends.get(i).getDirection()==1){
							results+=resultsArray[periode-1];
						}
						else if(newsTrends.get(i).getDirection()==-1){
							results-= resultsArray[periode-1];
						}
						
					}
					superResults[periode-1] += results;
				}
//				System.out.println(dirList[index].getName());
			}
			System.out.println("skriver til disk");
			FileOutputStream fos = new FileOutputStream("c:/master/resultsperTresholdinminutes/tresHold"+tresHold);
			ObjectOutputStream oos = new ObjectOutputStream(fos);
			oos.writeObject(superResults);
		}
//		Plot plotObj = new Plot();
//		plotObj.setTitle("tresHold: " + tresHold);
//		plotObj.setXLabel("Lengde p periode i minutter");
//		plotObj.setYLabel("resultat i norske kroner");
//		plotObj.setXRange(0, 121);
//		for(int i = 0; i<superResults.length;i++){
//			plotObj.addPoint(0, i+1, superResults[i], true);
//		}
//		
//		PlotApplication app = new PlotApplication(plotObj);
	}

}
