package testTing;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;

import stockPrices.TimeSeries;

public class CountTransactions {

	public static void main(String[] args) throws IOException, ClassNotFoundException{
		
		File[] dirList = new File("c:/master/timeseries/").listFiles();
		int numberOfTransactions = 0;
		for (int i = 0; i < dirList.length;i++){
			System.out.println(i);
			ObjectInputStream ois = new ObjectInputStream(new BufferedInputStream(new FileInputStream(dirList[i])));
			TimeSeries ts = (TimeSeries) ois.readObject();
			numberOfTransactions += ts.getPrices().size();
		}
		
		System.out.println("Total Number of transactions: " + numberOfTransactions);
	}
}
