package testTing;


import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Executor;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Future;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

import newsProcessor.NewsTrend;

public class CountTrend implements Serializable {
	
	public static void countTrends() throws IOException, ClassNotFoundException, InterruptedException, ExecutionException {
		
		int neg = 0;
		int pos = 0;
		int zero = 0;
		int error = 0;
		int wtf = 0;

		List<TrendSimulation> trendSimulations = Collections.synchronizedList(new ArrayList<TrendSimulation>());
		
		File dir = new File("c:/master/trendsbystock/");
		File[] dirList = dir.listFiles();
		int[] testArray = new int[dirList.length];
		int counter = 0;
		ExecutorService exService = new ThreadPoolExecutor(36, 36, 10, TimeUnit.SECONDS, new ArrayBlockingQueue<Runnable>(6, true), new ThreadPoolExecutor.CallerRunsPolicy());
		for(int i = 0; i<dirList.length;i++){

		
			Callable<TrendSimulation> t = new TrendSimulation(dirList[i].getAbsolutePath());
			Future<TrendSimulation> submit = exService.submit(t);
			trendSimulations.add(submit.get());
			System.out.println(trendSimulations.size());
		

//			trendSimulations.add(new TrendSimulation(period, thresHold, pos, neg, zero, error, wtf, directory));
		}
//}

		exService.shutdown();
		System.out.println(trendSimulations.size());
		
//		while(exService.awaitTermination(100, TimeUnit.SECONDS)){
//			
//		}
		FileOutputStream fos = new FileOutputStream(new File("c:/master/TrendsResults/simulationResults"));
		ObjectOutputStream oos = new ObjectOutputStream(fos);
		oos.writeObject(trendSimulations);
		
		
	}

}
