package testTing;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Future;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

import newsProcessor.News;

import crf.SelectRandomNews;

import stockPrices.TimeSeries;

public class Main implements Serializable {
	
	public static void main(String[] args) throws ClassNotFoundException, IOException, InterruptedException, ExecutionException {
//		CountTrend.countTrends();

//		PlotTrend.startPlot("AKSO", "20101011T090000");
		int periode = 15;
		double tresHold = 2.0;
//		double[] resultsArray = new double[120];
//		readSim(periode, tresHold);
//		File[] symboler = new File("c:/master/trendsbystock/trendsbystock1min1.0/").listFiles();
//		for(int i=0; i < symboler.length;i++ ){
//			TestReadArray.readArray(periode, tresHold, "NPRO", false, false);
//			break;
////			TestReadArray.readArray(periode, tresHold, symboler[i].getName(), true, true);
//		}
		
//		TestTradeExecutor.execute();
		PlotPeriodVsResults.plot(new File("C:\\Master\\Tradingsimulations\\PerfectInformation\\treshold0.5\\resultsArray"));
//		TestTrade2.createSalesSeries();
//		CombineNewsTrendsWithResults.readArrayAndCheckResults();
//		EvaluateAllTrades.getBestResults();
//		SelectRandomNews.getRandomNews();
//		readNewsText();
	}
	public static void readNewsText() throws IOException, ClassNotFoundException{
		
		FileInputStream fis = new FileInputStream(new File("c:/master/Processednewsbystock/vvl/279906"));
		ObjectInputStream ois = new ObjectInputStream(fis);
		News news = (News)ois.readObject();
		System.out.println(news.getMessage());
	}
	
	public static void readSim(int periode, double treshold) throws ClassNotFoundException, IOException, InterruptedException, ExecutionException {
		
		List<TrendSimulation> list = ReadTrendSimulations.readTrendSimulations("c:/master/trendsresults/simulationResults");
		System.out.println(list.size());
		
		int searchPeriod = periode;
		double searchTreshold = treshold;
		int index = getIndex(list, searchPeriod, searchTreshold);
		if(index>=0){
////			System.out.println(list.get(index).getDirectory());
////			System.out.println("pos: " + list.get(index).getPos());
////			System.out.println("neg: " + list.get(index).getNeg());
////			System.out.println("zero: " + list.get(index).getZero());
////			System.out.println("errors: " + list.get(index).getErrors());
////			System.out.println("WTF: " + list.get(index).getWtf());
//			
		}
		System.out.println(index);
		
	}
	public static int getIndex(List<TrendSimulation> list, int searchPeriod, double searchTreshold){
		for (int i = 0; i<list.size();i++){
			
			if ((list.get(i).getPeriod() == searchPeriod) && (list.get(i).getThresHold() == searchTreshold)) {
				return i;
			}
			
		}
		return -1;
		
	}
}
