package testTing;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.util.ArrayList;

import ptolemy.*;
import ptolemy.plot.Plot;
import ptolemy.plot.PlotApplication;
import stockPrices.TimeSeries;
import trends.ClosestTime;

public class PlotTrend {
	
	public static void plotTrend(String name, ArrayList<Integer> xArray, ArrayList<Integer> yArray){
		
		System.out.println("HELLO");		
		Plot plotObj = new Plot();
		plotObj.setTitle(name);
		plotObj.setXLabel("Tid");
		plotObj.setYLabel("Pris");
		
		for(int index = 0; index < xArray.size();index++){
			
			plotObj.addPoint(0, xArray.get(index), yArray.get(index), true);
		}
		
		PlotApplication app = new PlotApplication(plotObj);
		
		
	}
	
	public static void startPlot(String name, String date) throws IOException, ClassNotFoundException{
		
		ArrayList<Integer> x = new ArrayList<>();
		ArrayList<Integer> y = new ArrayList<>();
		System.out.println("test1");
		int day = Integer.parseInt(date.substring(0,8));
		
		FileInputStream fis = new FileInputStream(new File("c:/master/timeseries/"+ name));
//		BufferedInputStream bis = new BufferedInputStream(fis);
		ObjectInputStream ois = new ObjectInputStream(fis);
		
		TimeSeries ts = (TimeSeries)ois.readObject();
		System.out.println("test2");
		ClosestTime ct = new ClosestTime(date, ts);
		int transnum = ct.getTransactionID()+1;
//		
//		modelTrend(name, day, 90000, ct.getTransactionID()+1, 90, ts);
		System.out.println("test3");
		while (ts.getDate().get(transnum)== day){
		x.add(Integer.parseInt(ts.getTime().get(transnum).substring(date.length()-6, date.length()-2)));
		double tempY = ts.getPrices().get(transnum);
		int tempYint = (int)tempY;
		y.add(tempYint);
		transnum++;
	}
		plotTrend(name, x, y);
	
		
	}
	

}
