package testTing;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.util.ArrayList;

import newsProcessor.News;
import newsProcessor.NewsTrend;
public class TestReadArray {
	
	public static ArrayList<NewsTrend> readArray(int period, double tresHold, String name, boolean returnOnlyTrends, boolean returnOnlyMiddayNews) throws ClassNotFoundException, IOException{
		ArrayList<NewsTrend> list = new ArrayList<>();
		FileInputStream fis = new FileInputStream(new File("C:\\Master\\trendsbystock\\trendsbystock"+period +"min"+tresHold+"\\"+name+"\\newstrends"));
		ObjectInputStream ois = new ObjectInputStream(fis);
		list = (ArrayList<NewsTrend>) ois.readObject();
		
//		System.out.println(name);
		for(int i = 0; i<list.size();i++){
			
			FileInputStream fis2 = new FileInputStream(new File("C:/master/processednewsbystock/"+name+"/" + list.get(i).getName()));
			ObjectInputStream ois2 = new ObjectInputStream(fis2);
			News news = (News) ois2.readObject();
			int timeOfDay = Integer.parseInt(news.getDate().substring(news.getDate().length()-6));
			if(returnOnlyMiddayNews){
				if(timeOfDay<90000){
					continue;
				}
				else if(timeOfDay>173000){
					continue;
				}
			}
			int direction = list.get(i).getDirection();
			if(returnOnlyTrends){
				if(direction == 1 || direction == -1){
				System.out.println(list.get(i).getName() + ": " + direction);
				
				}
			}
			else {
				System.out.println(list.get(i).getName() + ": " + direction);
			}
		}
		
		
		return list;
		
	}

}
