package testTing;

import ptolemy.plot.Plot;
import ptolemy.plot.PlotApplication;

public class TestTradeFindTransCost {
	

	public static void main(String[] args) {
		
		double increase = 1.00098;
		
		double fractionToInvest = 0.2;
		double transCost = 0.00039;
		int totalTrades = 9503;
		
		Plot plotObj = new Plot();
		plotObj.setTitle("Results vs transaction costs");
		plotObj.setXLabel("TransCost");
		plotObj.setYLabel("Results");
//		int chargeDay = (int) Math.floor((double)20.7*100);
		int chargeDay = 1;
		Plot costsPaid = new Plot();
		costsPaid.setTitle("Paid Transaction Costs vs Transaction Costs");
		costsPaid.setXLabel("transCost ");
		costsPaid.setYLabel("Total TransCosts paid divided by starting capital." );
		
		Plot transDay = new Plot();
		transDay.setTitle("Resultater vs hvor ofte man betaler kurtasje");
		transDay.setXLabel("days between transCost Deduction");
		transDay.setYLabel("resultat i kroner");
		double realStartCapital = 100000000;
		for(transCost = 0.00000;transCost<0.001;transCost+=0.00001){
//			System.out.println(transCost);
//		for(int dayBetweenTransCost = 1;dayBetweenTransCost<500; dayBetweenTransCost++){
//			chargeDay = (int) Math.floor(20.7*dayBetweenTransCost);
			double startCapital = realStartCapital;
			double totalTransCost = 0;
			double runningTransCost = 0;
			for(int i = 0; i < totalTrades; i++){
				if (i%chargeDay == 0){
					startCapital-= runningTransCost;
					totalTransCost+= runningTransCost;
					
					runningTransCost= 0;
				}
				double preCost = startCapital*fractionToInvest*transCost;
				double postCost = startCapital*fractionToInvest*increase*transCost;
				
//				if(preCost<59){
//					preCost = 59;
//				}
//				if(postCost<59){
//					postCost=59;
//				}
				
				runningTransCost += preCost + postCost;
				
				startCapital = startCapital - startCapital*fractionToInvest + startCapital*fractionToInvest*increase;
				
			}
			startCapital -= runningTransCost;
			totalTransCost += runningTransCost;
			double result = (startCapital-realStartCapital)/realStartCapital;
			if(transCost==0){
				System.out.println(result);
			}
			else if(transCost == 3.5000000000000027E-4){
				System.out.println(result);
			}
//			transDay.addPoint(0, dayBetweenTransCost, startCapital, true);
//			System.out.println(totalTransCost);
			plotObj.addPoint(0, transCost, (startCapital-realStartCapital)/realStartCapital, true);
			costsPaid.addPoint(0, transCost, totalTransCost/realStartCapital, true);
//			System.out.println(startCapital + " end result");
//			System.out.println(totalTransCost + " paid in transactioncosts");
		}
		
		PlotApplication app = new PlotApplication(plotObj);
		PlotApplication app2 = new PlotApplication(costsPaid);
//		PlotApplication app3 = new PlotApplication(transDay);
		
	}


}
