package trends;

import stockPrices.TimeSeries;

// This class finds the last transaction before a given time. 
public class ClosestTime {
	
	public int getOffset() {
		return offset;
	}


	public void setOffset(int offset) {
		this.offset = offset;
	}


	public int getTransactionID() {
		return TransactionID;
	}


	public void setTransactionID(int transactionID) {
		TransactionID = transactionID;
	}


	int offset;
	int dayDiff;
	String prevTime;
	int TransactionID;
	public boolean isAfterClosing;
	public boolean isFalse;
	
	
	public ClosestTime(String time, TimeSeries ts){
		
		
		
		boolean foundTransaction = false;
//		System.out.println(time);
		int day = Integer.parseInt(time.substring(0,8));
		if (day<20091103){
			return;
		}
		int timeOfDay = Integer.parseInt(time.substring(time.length()-6));
		int saveDay = day;
		int saveTime = timeOfDay;
		setAfterClosing((timeOfDay>=173000)||(timeOfDay<=90000));
	
		int transNum = ts.getDate().size() /2;
		int lastSmaller = 0;
		int lastBigger = ts.getTime().size();
		int prevTrans = 0;
		
//		System.out.println(timeOfDay);
//		System.out.println(day);
		for (int i = 0; i < 8; i++) {
			if(!ts.getDate().contains(day)){
				if(timeOfDay>173000){
					day--;
					}
				if (timeOfDay<90000) {
					
					day++;
				}
				if (day%100>31){
					day+=70;
				}
				if (day%10000>1300){
					day+=8800;
				}
			}
		}
		
//		System.out.println(day);
		if (ts.getTime().size()==0){
			setFalse(true);
			return;
		}
		if(ts.getDate().get(ts.getDate().size()-1)<day){
			setFalse(true);
			return;
		}
		setFalse(false);
		while (foundTransaction == false){
			
			int searchDay = Integer.parseInt(ts.getTime().get(transNum).substring(0,8));
//			System.out.println(searchDay);
			if(searchDay==day){
				
				
				if (Integer.parseInt(ts.getTime().get(transNum).substring(time.length()-6))<timeOfDay) {
//					System.out.println("HELP!");
					
					while(Integer.parseInt(ts.getTime().get(transNum).substring(time.length()-6))<timeOfDay){
						if(ts.getDate().get(transNum)>day){
							transNum--;
							break;
						}
						transNum++;
						if (transNum==ts.getDate().size()){
							setFalse(true);
							return;
						}
					}
					prevTrans = transNum -1;
					foundTransaction=true;
					
				}
				else if(Integer.parseInt(ts.getTime().get(transNum).substring(time.length()-6))>timeOfDay){
//					System.out.println("DONT HELP!");
					
					while(Integer.parseInt(ts.getTime().get(transNum).substring(time.length()-6))>timeOfDay){
						if (ts.getDate().get(transNum)<day) {
//							transNum++;
							break;
						}
						transNum--;
						if (transNum==-1){
							setFalse(true);
							return;
							
						}
					}
					prevTrans= transNum-1;
					foundTransaction=true;
					
				}
				else if(Integer.parseInt(ts.getTime().get(transNum).substring(time.length()-6))==timeOfDay){
					prevTrans= transNum;
					foundTransaction=true;
				}
			}
			else if(searchDay<day+20 && searchDay>day-20){
				
				
				if(searchDay<day){
					
					while(ts.getDate().get(transNum)<day){
					
						transNum++;
						
					}
					
					if(ts.getDate().get(transNum)==day){
						
						if (Integer.parseInt(ts.getTime().get(transNum).substring(time.length()-6))<timeOfDay) {
//							System.out.println("HELP!");
							
							while(Integer.parseInt(ts.getTime().get(transNum).substring(time.length()-6))<timeOfDay){
								if(ts.getDate().get(transNum)>day){
									transNum--;
									break;
								}
								transNum++;
								if (transNum == ts.getTime().size()){
									setFalse(true);
									return;
								}
							}
							prevTrans = transNum -1;
							foundTransaction=true;
							
						}
						else if(Integer.parseInt(ts.getTime().get(transNum).substring(time.length()-6))>timeOfDay){
//							System.out.println("DONT HELP!");
							
							while(Integer.parseInt(ts.getTime().get(transNum).substring(time.length()-6))>timeOfDay){
								if (ts.getDate().get(transNum)<day) {
//									transNum++;
									break;
								}
								transNum--;
							}
							prevTrans= transNum-1;
							foundTransaction=true;
							
						}
						else if(Integer.parseInt(ts.getTime().get(transNum).substring(time.length()-6))==timeOfDay){
							prevTrans= transNum;
							foundTransaction=true;
						}
					}
					else{
						prevTrans=transNum-1;
						foundTransaction=true;
					}
				}
				else {
					
					while(ts.getDate().get(transNum)>day){
						transNum--;
						if (transNum==-1){
							setFalse(true);
							return;
						}
					}
					if(ts.getDate().get(transNum)==day){
						
						if (Integer.parseInt(ts.getTime().get(transNum).substring(time.length()-6))<timeOfDay) {
//							System.out.println("HELP!");
							
							while(Integer.parseInt(ts.getTime().get(transNum).substring(time.length()-6))<timeOfDay){
								if(ts.getDate().get(transNum)>day){
									transNum--;
									break;
								}
								transNum++;
							}
							prevTrans = transNum -1;
							foundTransaction=true;
							
						}
						else if(Integer.parseInt(ts.getTime().get(transNum).substring(time.length()-6))>timeOfDay){
//							System.out.println("DONT HELP!");
//							if(ts.getName().equals("ALGETA")){
//								System.out.println("KOJASNJDAS");
//							}
							while(Integer.parseInt(ts.getTime().get(transNum).substring(time.length()-6))>timeOfDay){
								if (transNum==0){
									setFalse(true);
									return;
								}
								if (ts.getDate().get(transNum)<day) {
									
//									transNum++;
									break;
								}
								transNum--;
							}
							prevTrans= transNum-1;
							foundTransaction=true;
							
						}
						else if(Integer.parseInt(ts.getTime().get(transNum).substring(time.length()-6))==timeOfDay){
							prevTrans= transNum;
							foundTransaction=true;
						}
					}
					else{
						prevTrans=transNum;
						foundTransaction=true;
					}
				}
			}
			else if(searchDay<day){
//				if(ts.getName().equals("AKVA")){
//					System.out.println("HJELP!");
//					System.out.println(searchDay + " " + day);
//				}
//				System.out.println("HER ER JEG");
//				System.out.println("DAYTOOSMALL");
//				System.out.println(transNum);
//				System.out.println(lastSmaller);
				if (lastSmaller == transNum){
					int saveNum = transNum;
					while (ts.getDate().get(transNum)<day){
						transNum++;
						if (transNum == ts.getDate().size()){
							transNum=0;
						}
						if (transNum == saveNum-1){
							setFalse(true);
							return;
						}
						
								
						
					}
				}
				else{
					lastSmaller=transNum;
					transNum=(transNum+lastBigger)/2;
				}
				
//				System.out.println(transNum);
				
//				System.out.println(transNum);
				
			}
			else if (searchDay>day){
				
				if (lastBigger == transNum){
					int saveTrans = transNum;
					while(ts.getDate().get(transNum)>day){
						transNum--;
						if (transNum==0){
							transNum = ts.getDate().size();
						}
						if (saveTrans==transNum+1){
							setFalse(true);
							return;
						}
						
					}
				}
				else {
					lastBigger=transNum;
//					System.out.println(transNum);
					transNum=(transNum+lastSmaller)/2;
//					
					
				}
//				System.out.println("DAYTOOBIG");
//				System.out.println(transNum);
			}
			
		}
		setDayDiff(saveDay-ts.getDate().get(transNum));
		setOffset(saveTime-Integer.parseInt(ts.getTime().get(transNum).substring(time.length()-6)));
		setTransactionID(transNum);
		setPrevTime(ts.getTime().get(transNum));
		
		
		
		
//		while (foundTransaction == false){
//			String newTimeOfDay = Integer.toString(timeOfDay);
//			while(newTimeOfDay.length()<6){
//				newTimeOfDay = '0' + newTimeOfDay;
//			}
//			String newTime = Integer.toString(day) + 'T' + newTimeOfDay;
//			if(ts.getTime().contains(newTime)){
//				setPrevTime(newTime);
//				int tempdiff=timeOfDay-saveTime;
////				if (tempdiff%10000>6000){
////					tempdiff-=4000;
////				}
//				setOffset(tempdiff);
//				setDayDiff(day-saveDay);
//				setTransactionID(ts.getTime().indexOf(newTime));
//				foundTransaction = true;
//			}
//			
//			timeOfDay--;
//			if (timeOfDay%10000>6000){
//				timeOfDay-=4000;
//			}
//			if(timeOfDay<83000){
//				day--;
//				if (day%100==0){
//					day-=100;
//					day+=31;
//				}
//				
//				if (day%10000==0){
//					day-=10000;
//					day+=1200;
//				}
//				timeOfDay=173000;
//			}
//			if (day<20091102){
//				break;
//			}
			
//		}
		
		
	}


	public boolean isFalse() {
		return isFalse;
	}


	public void setFalse(boolean isFalse) {
		this.isFalse = isFalse;
	}


	public boolean isAfterClosing() {
		return isAfterClosing;
	}


	public void setAfterClosing(boolean isAfterClosing) {
		this.isAfterClosing = isAfterClosing;
	}


	public int getDayDiff() {
		return dayDiff;
	}


	public void setDayDiff(int dayDiff) {
		this.dayDiff = dayDiff;
	}


	public String getPrevTime() {
		return prevTime;
	}


	public void setPrevTime(String prevTime) {
		this.prevTime = prevTime;
	}

}
