package baseLine;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;

import newsProcessor.NewsTrend;

public class CreateBaseLineFiles {
	
	public static void main(String[] args) throws IOException, ClassNotFoundException {
		File[] dir = new File("c:/master/trendsbystock/trendsbystock44min0.5/").listFiles();
		ArrayList<String> FeatureVector = new ArrayList<String>();
		
		int count = 0;
		for(int i = 0; i < dir.length; i++){
//			for(int i = 0; i < 10; i++){
				ObjectInputStream oisNT = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/trendsbystock/trendsbystock44min0.5/"+dir[i].getName()+"/newstrends"))));
				ArrayList<NewsTrend> nt = (ArrayList<NewsTrend>) oisNT.readObject();
				
				for(int lol = 0; lol<nt.size(); lol++){
					
					String name = nt.get(lol).getDirectory().substring(nt.get(lol).getDirectory().length()-6) + ".txt";
					if (!new File("c:/master/CRFresulttest/" + name).exists()) {
						continue;
					}
					count++;
					BufferedReader br = new BufferedReader(new FileReader(new File("c:/master/CRFresulttest/" + name)));
					String content = "";
					try{
						while (br.ready()){
							content = br.readLine();
							String tempTerm = "";
							for(int j = 0; j<content.length();j++){
								if(content.charAt(j)=='\t'){
									break;
								}
								else {
									tempTerm+=content.charAt(j);
								}
							}
							if(!FeatureVector.contains(tempTerm)){
								FeatureVector.add(tempTerm);
							}
							
						}
					}catch (Exception e) {
						// TODO: handle exception
					}
				}
			}
			ArrayList<Integer> documentFrequency = new ArrayList<>();
			for(int fill = 0; fill < FeatureVector.size(); fill++){
				documentFrequency.add(0);
			}
		System.out.println("FeatureVector built");
		for(int i = 0; i < dir.length; i++){
//		for(int i = 0; i < 10; i++){
			ObjectInputStream oisNT = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/trendsbystock/trendsbystock44min0.5/"+dir[i].getName()+"/newstrends"))));
			ArrayList<NewsTrend> nt = (ArrayList<NewsTrend>) oisNT.readObject();
			
			for(int lol = 0; lol<nt.size(); lol++){
					
				ArrayList<Integer> tempDocFreq = new ArrayList();
				for(int fill = 0; fill < FeatureVector.size(); fill++){
					tempDocFreq.add(0);
				}
				String name = nt.get(lol).getDirectory().substring(nt.get(lol).getDirectory().length()-6) + ".txt";
				if (!new File("c:/master/CRFresulttest/" + name).exists()) {
					continue;
				}
				BufferedReader br = new BufferedReader(new FileReader(new File("c:/master/CRFresulttest/" + name)));
				String content = "";
			
					while (br.ready()){
						content = br.readLine();
						String tempTerm = "";
						for(int j = 0; j<content.length();j++){
							if(content.charAt(j)=='\t'){
								break;
							}
							else {
								tempTerm+=content.charAt(j);
							}
						}
						int index = FeatureVector.indexOf(tempTerm);
						if(tempDocFreq.get(index)!=0){
							continue;
						}
						else{
							tempDocFreq.set(index, 1);
							}
					}
						
				for(int k = 0; k<tempDocFreq.size();k++){
					int temp = documentFrequency.get(k);
					temp+= tempDocFreq.get(k);
					documentFrequency.set(k, temp);
				}
			}
		}
		System.out.println("DocumentFeatures built");
		System.out.println("before: " + documentFrequency.size());
		
		for(int i = documentFrequency.size()-1; i>=0;i--){
			if(documentFrequency.get(i)>10000){
				documentFrequency.remove(i);
				FeatureVector.remove(i);
			}
		}
		System.out.println("after: " + documentFrequency.size());
		ObjectOutputStream oos = new ObjectOutputStream(new BufferedOutputStream(new FileOutputStream(new File("c:/master/Baseline/Featurevector"))));
		oos.writeObject(FeatureVector);
		oos.close();
		ObjectOutputStream oos2 = new ObjectOutputStream(new BufferedOutputStream(new FileOutputStream(new File("c:/master/Baseline/DFVector"))));
		oos2.writeObject(documentFrequency);
		oos2.close();
		BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream(new File("c:/masteR/baseline/wekaBaseline.arff")));
		
		String outputString = "@relation Baseline\n";
		for(int k = 0; k<FeatureVector.size();k++){
			outputString+="@ATTRIBUTE\t";
			outputString+= k+1;
			
			
			outputString+="\tNUMERIC\n";
			bos.write(outputString.getBytes());
			outputString="";
		}	
		outputString += "Attribute\tclass\t{pos,neg,zero}\n";
		bos.write(outputString.getBytes());
		outputString="";
		for(int i = 0; i < dir.length; i++){
			System.out.println(dir[i].getName());
//		for(int i = 0; i < 10; i++){
			ObjectInputStream oisNT = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/trendsbystock/trendsbystock44min0.5/"+dir[i].getName()+"/newstrends"))));
			ArrayList<NewsTrend> nt = (ArrayList<NewsTrend>) oisNT.readObject();
//			System.out.println(dir[i].getName());
			for(int lol = 0; lol<nt.size(); lol++){
				if(nt.get(lol).getDirection()==-2){
					continue;
				}
				
				ArrayList<Integer> tf = new ArrayList<>();
				for(int fill = 0; fill < FeatureVector.size();fill++){
					tf.add(0);
				}
				String name = nt.get(lol).getDirectory().substring(nt.get(lol).getDirectory().length()-6) + ".txt";
//				System.out.println(name);
				if (!new File("c:/master/CRFresulttest/" + name).exists()) {
					continue;
				}
				BufferedReader br = new BufferedReader(new FileReader(new File("c:/master/CRFresulttest/" + name)));
//				System.out.println(name);
				String content = "";
			
					while (br.ready()){
						content = br.readLine();
						String tempTerm = "";
						for(int j = 0; j<content.length();j++){
							if(content.charAt(j)=='\t'){
								break;
							}
							else {
								tempTerm+=content.charAt(j);
							}
						}
						int index = FeatureVector.indexOf(tempTerm);
						if(index != -1){
							int tempTF = tf.get(index);
							tempTF++;
							tf.set(index, tempTF);
						}
//						System.out.println(content);
					}
					Double[] tfidf = new Double[FeatureVector.size()];
					
					outputString+="{";
					for (int k = 0; k < FeatureVector.size(); k++) {
//						if(k%1000==0){
//							System.out.println(k);
//						}
						int tempTF = tf.get(k);
						double idf = Math.log(count/documentFrequency.get(k));
						double tempDouble = tempTF*idf;
						tfidf[k] = tempDouble;
						if(tempDouble>0){
							outputString+="" + (k+1) + " " + tempDouble;
							bos.write(outputString.getBytes());
							outputString=",";
						}
					}
					int featuresize = FeatureVector.size();
					int direction = nt.get(lol).getDirection();
					switch(direction){
					case(-1):outputString+=featuresize + " neg";break;
					case(1):outputString+=featuresize +" pos";break;
					case(0):outputString+=featuresize + " zero";break;
					}
					outputString="";
					outputString+="}\n";
					
//					System.out.println("ferdig med filen.");
			}
			
		}

		
		bos.write(outputString.getBytes());
		bos.close();
		
			
	
	}
}
