package newsProcessor;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.HashMap;

import trends.RegressionObject;

public class RegressionobjectsToTaggedFiles {
	
	public static void main(String[] args) throws FileNotFoundException, IOException, ClassNotFoundException {
	
		File dir = new File("c:/master/Regressionresults/");
		
		File[] dirList = dir.listFiles();
		HashMap<String, RegressionObject> hm = new HashMap<>();
		
		for(int i = 0; i< dirList.length; i++){
			ObjectInputStream ois = new ObjectInputStream(new BufferedInputStream(new FileInputStream(dirList[i].listFiles()[0])));
			
			ArrayList<ArrayList<RegressionObject>> list = (ArrayList<ArrayList<RegressionObject>>) ois.readObject();
			for(int j = 0; j<list.size(); j++){
				for(int k = 0; k < list.get(j).size();k++){
					
					hm.put(list.get(j).get(k).getNameOfNews()+"min"+(j+1), list.get(j).get(k));
					
				}
				
			}
			
		}
		
		ObjectOutputStream oos = new ObjectOutputStream(new BufferedOutputStream(new FileOutputStream(new File("c:/master/regressionResultsHashmap/HashMap"))));
		oos.writeObject(hm);
		oos.close();
	}
	
	
	

}
