package svm;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;

public class TfIdfvector {
	
	
public static void main(String[] args) throws ClassNotFoundException, IOException, InterruptedException {
		
		ObjectInputStream ois2 = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/svmprocess/FeatureVector2"))));
		ArrayList<Feature> featureVector = (ArrayList<Feature>) ois2.readObject();
		
		File[] dirList = new File("c:/master/svmprocess/termFrequency2/").listFiles();
		ObjectInputStream ois3 = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/svmprocess/documentFrequency2"))));
		ArrayList<Integer> documentFrequency = (ArrayList<Integer>) ois3.readObject();
		int numberOfFiles = dirList.length;
		
		System.out.println(numberOfFiles);
		
		for(int index = 0; index < dirList.length; index++){
			
			ArrayList<Double> tfIdfVector = new ArrayList<>();
			ObjectInputStream ois = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/svmprocess/termFrequency2/" + dirList[index].getName()))));
			ArrayList<Integer> termFrequency = (ArrayList<Integer>) ois.readObject();
			
			ObjectOutputStream oos = new ObjectOutputStream(new BufferedOutputStream(new FileOutputStream(new File("c:/master/svmprocess/tfidf2/" + dirList[index].getName()))));
//			String outputString = "";
			
//			System.out.println(featureVector.size());
			int vectorSize = documentFrequency.size();
			for(int i = 0; i < featureVector.size(); i ++){
				
				int docFreq = documentFrequency.get(i);
				int termFreq = termFrequency.get(i);
				double idf = Math.log((double)numberOfFiles/docFreq);
				double tfIdf = termFreq*idf;
				tfIdfVector.add(tfIdf);
				
				
	//			else {
	//			System.out.println(outputString);
	//			}
				
				
				
			}
			oos.writeObject(tfIdfVector);
			oos.close();
			
		}
	}

}
