package testTing;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.ObjectInputStream;

import ptolemy.*;
import ptolemy.plot.Plot;
import ptolemy.plot.PlotApplication;

public class PlotPeriodVsResults {
	
	public static void plot(File resultsArray) throws ClassNotFoundException, IOException{
		
		
		Plot plotObj = new Plot();
		plotObj.setTitle("Resultater vs periode");
		plotObj.setXLabel("Periode i minutter");
		plotObj.setYLabel("Resultat i kroner");
		
		FileInputStream fis = new FileInputStream(resultsArray);
//		BufferedInputStream bis = new BufferedInputStream(fis);
		ObjectInputStream ois = new ObjectInputStream(fis);
		double[] results = (double[])ois.readObject();
		
		for (int i = 0; i < results.length; i++) {
			plotObj.addPoint(0, i+1, results[i], true);
		}
		
		PlotApplication app = new PlotApplication(plotObj);
	}
	
	

}
