package weka;

import java.util.ArrayList;

import svm.TfIdfvector;
import weka.classifiers.Classifier;
import weka.core.Attribute;
import weka.core.FastVector;
import weka.core.Instance;
import weka.core.Instances;
import weka.gui.streams.InstanceLoader;

public class ClassifyUnkown {
	
	
	public static Instances getInstance(ArrayList<Double> inputVector){
		
		FastVector fvWekaAttributes = new FastVector(inputVector.size());
		for(int i= 0; i < inputVector.size();i++){
			fvWekaAttributes.addElement(new Attribute(""+i));
		}
		FastVector fvClassVal = new FastVector(3);
		fvClassVal.addElement("pos");
		fvClassVal.addElement("neg");
		fvClassVal.addElement("zero");
		
		Attribute ClassAttribute = new Attribute("Class", fvClassVal);
		
		fvWekaAttributes.addElement(ClassAttribute);
		Instance instance = new Instance(inputVector.size()+1);
		Instances isTrainingset = new Instances("Rel", fvWekaAttributes, 1);
		
		for(int i = 0; i <inputVector.size();i++){
			
			instance.setValue((Attribute) fvWekaAttributes.elementAt(i),inputVector.get(i));
			
		}
		instance.setValue((Attribute) fvWekaAttributes.elementAt(instance.numValues()-1), "zero");
		isTrainingset.setClassIndex(instance.numAttributes()-1);
		isTrainingset.add(instance);
		return isTrainingset;
	}
	
	public static double[] doClassification(Instances isTrainingset, Classifier model) throws Exception{
		
		
		
		
		double[] results = model.distributionForInstance(isTrainingset.firstInstance());
		
		
		
		return results ;
		
		
	}

}
